short parseShortBytes(byte[] data, int initialIndex) {
  short number;
  number = (short)( ((data[1+initialIndex] & 0xFF) << 8) |  (data[initialIndex] & 0xFF) );
  return(number);
}

void serialEvent(Serial arduino) {
    if(!started) {
     arduino.clear();
     return;
    }
    
    arduino.readBytes(dataIn);
    
    if (dataIn[payloadSize] != 10) {
      thread("sync");
      //break;
      println("Unsynced");
      return;
    }
    
    for (int i = 0; i < 6; i++) {
      accgyr[i] = parseShortBytes(dataIn, i*2);
    }
    
   
    // process data
    accGs[0] = accToGs(accgyr[0]);
    accGs[1] = accToGs(accgyr[1]);
    accGs[2] = accToGs(accgyr[2]);
    gyrDps[0] = gyroToDps(accgyr[3]);
    gyrDps[1] = gyroToDps(accgyr[4]);
    gyrDps[2] = gyroToDps(accgyr[5]);

    /// for the graphs
    
    accSeries[index][0] = accgyr[0];
    accSeries[index][1] = accgyr[1];
    accSeries[index][2] = accgyr[2];

    gyrSeries[index][0] = accgyr[3];
    gyrSeries[index][1] = accgyr[4];
    gyrSeries[index][2] = accgyr[5];

    index = (index + 1) % dataL;


    // orientation estimation
    if (firstDataFlag){
     firstDataFlag = false;
     
     startFilter();
    }
}

void sync() {
  println("Syncing");
  arduino.readBytesUntil(10); // As the character "10" is always the last character in a packet from the arduino
  println("Synced");
}
