/*
  Requires the following libraries:
  ToxicLibs by Karsten Schmidt

  NOTE:
    Change serialPort variable (on line 9) to the port of your arduino board
*/

String serialPort = "COM7";

import processing.serial.*;
import toxi.geom.*; // Quaternion

// Serial communication
Serial arduino;
int controlCharacter = 10;
final int payloadSize = 12; // *
byte dataIn[] = new byte[payloadSize + 1];

// data
boolean firstDataFlag = true;
boolean goodData = false;

short accgyr[] = new short[6];

float accGs[] = new float[3];
float gyrDps[] = new float[3];

// for the graphs
int dataL = 500; // ammount of data to show in the graph

short accSeries[][] = new short[dataL][3];
short gyrSeries[][] = new short[dataL][3];
int index = 0; // index for graphs

PGraphics accG;
PGraphics gyrG;

boolean started = false;

//Orientation estimation
Madgwick filter;
int sampleRate = 200; 
long microsPerReading = 1000000 / sampleRate;
long microsPrevious = 0;

void setup(){
 size(700, 700, P3D);
 
 for (int i = 0; i < 6; i++){
   accgyr[i] = 0; 
 }
 // Serial
 arduino = new Serial(this, serialPort, 115200);
 arduino.buffer(payloadSize + 1);

 // Graphs
 accG = createGraphics(250, 200);
 gyrG = createGraphics(250, 200);
 
 //orientation estimation
 filter = new Madgwick();
 filter.begin(sampleRate);
 
 started = true;
}

void draw(){
 background(0);
 
 drawOnGraphs();
 displayGraphs();
 
 
 // Draw rocket model
 translate(width/2 + 120, height/2);
 Quaternion a = new Quaternion(filter.q0, filter.q1, filter.q2, filter.q3);
 float angs[] = a.toAxisAngle();
 lights();
 rotate(-angs[0], angs[1], angs[3], angs[2]);
 fill(255, 117, 24);
 box(200, 50, 50);
}
